
alias tabs { 
  if ($dialog(tabs)) { dialog -x tabs tabx }
  else { dialog -m tabs tabs }
}

dialog tabs {
  size -1 -1 550 502
  title "Guitar Tabs Viewer"
  icon tab.ico
  button "OK" 1, 311 474 74 24,ok
  icon 2, 0 0 550 100, guitar.jpg
  box "" 3, -5 119 570 39
  button "Cancel" 4, 391 474 74 24, cancel
  text "" 5, -5 125 570 34
  text "Artist:" 6, 10 135 50 15
  edit "" 7, 50 131 120 23
  text "Song:" 8, 180 135 50 15
  edit "" 9, 220 131 140 23
  text "In:" 10, 370 135 20 15
  combo 11, 395 131 120 200, drop
  text "Standing By..." 12, 10 106 330 15
  button "!" 13, 520 131 22 20, default
  box "" 14, 5 462 540 8
  edit "" 15, 5 163 540 270, multi pass vsbar autovs return

  text "Artist" 16, 15 15 300 24
  text "Song name" 17, 15 37 300 22
  text "" 18, 15 65 300 15

  check "Preferences" 19, 5 474 90 24, push

  box "" 20, 5 431 540 8
  text "Font:" 21, 8 447 40 15 
  combo 22, 44 443 120 200, drop sort
  text "Size:" 23, 173 447 50 15
  edit "" 24, 203 442 60 22

  text "R:" 25, 274 447 20 15
  edit "" 26, 294 442 50 22
  text "G:" 27, 350 447 20 15
  edit "" 28, 370 442 50 22
  text "B:" 29, 430 447 20 15
  edit "" 30, 450 442 50 22
  box "" 31, 515 436 30 29
  text "" 32, 516 442 27 22

  button "Apply" 33, 471 474 74 24

}

on *:dialog:tabs:init:0: {
  mdx SetMircVersion $version
  mdx MarkDialog $dname
  if (!$gettok(%tabs,7,44)) { set %tabs Bright,11,255,255,255,0,1 }
  mdx SetFont $dname 16 +a 24 600 Verdana
  mdx SetFont $dname 17 +a 18 600 Verdana
  mdx SetFont $dname 15 +a $gettok(%tabs,2,44) 400 $gettok(%tabs,1,44)
  did -f $dname 7
  did -m $dname 15
  did -b $dname 16,17,18
  didtok $dname 22 44 Bright,Courier New,Lucida Console,Terminal,Fixedsys
  didtok $dname 11 44 Guitartabs.cc,Olga.net,Ultimate-Guitar.com
  mdx SetColor $dname 16,17,18 textbg $rgb(232,232,232)
  mdx SetColor $dname 16,17,18 background $rgb(232,232,232)
  mdx SetColor $dname 32 background $rgb(255,255,255)
  mdx SetColor $dname 6,8,10,14 textbg $rgb(222,219,214)
  mdx SetColor $dname 6,5,8,10,14 background $rgb(222,219,214)
  mdx SetControlMDX $dname 24,26,28,30 UpDown edit alignright numeric > $scriptdirctl_gen.mdx
  mdx SetBorderStyle 24,26,28,30 clientedge
  did -i $dname 24 1 $gettok(%tabs,2,44) 1 50 1 1:1
  did -i $dname 26 1 $gettok(%tabs,3,44) 0 255 1 1:1
  did -i $dname 28 1 $gettok(%tabs,4,44) 0 255 1 1:1
  did -i $dname 30 1 $gettok(%tabs,5,44) 0 255 1 1:1
  did -c $dname 22 $didwm($dname,22,$gettok(%tabs,1,44))
  did -c $dname 11 $gettok(%tabs,7,44)

  if ($gettok(%tabs,6,44) = 1) { did -c $dname 19 }
  _tabs_pref

  var %r = $gettok(%tabs,3,44) 
  var %g = $gettok(%tabs,4,44) 
  var %b = $gettok(%tabs,5,44) 
  mdx SetColor $dname 15,32 background $rgb(%r,%g,%b)
  mdx SetColor $dname 15 textbg $rgb(%r,%g,%b)
}

on *:dialog:tabs:sclick:19: {
  _tabs_pref
}

on *:dialog:tabs:edit:*: {
  if ($did = 26 || $did = 28 || $did = 30) {
    var %r = $gettok($did($dname,26),1,32) 
    var %g = $gettok($did($dname,28),1,32) 
    var %b = $gettok($did($dname,30),1,32) 
    mdx SetColor $dname 32 background $rgb(%r,%g,%b)
  }
}

on *:dialog:tabs:sclick:1: {
  var %f = $did($dname,22)
  var %s = $gettok($did($dname,24),1,32)
  var %r = $gettok($did($dname,26),1,32)
  var %g = $gettok($did($dname,28),1,32)
  var %b = $gettok($did($dname,30),1,32)
  set %tabs %f $+ , $+ %s $+ , $+ %r $+ , $+ %g $+ , $+ %b $+ , $+ $did($dname,19).state $+ , $+ $did($dname,11).sel
}

on *:dialog:tabs:sclick:33: {
  mdx SetFont $dname 15 +a $gettok($did($dname,24),1,32) 400 $did($dname,22)
  var %r = $gettok($did($dname,26),1,32) 
  var %g = $gettok($did($dname,28),1,32) 
  var %b = $gettok($did($dname,30),1,32) 
  mdx SetColor $dname 15 background $rgb(%r,%g,%b)
  mdx SetColor $dname 15 textbg $rgb(%r,%g,%b)

  var %f = $did($dname,22)
  var %s = $gettok($did($dname,24),1,32)
  var %r = $gettok($did($dname,26),1,32)
  var %g = $gettok($did($dname,28),1,32)
  var %b = $gettok($did($dname,30),1,32)
  set %tabs %f $+ , $+ %s $+ , $+ %r $+ , $+ %g $+ , $+ %b $+ , $+ $did($dname,19).state $+ , $+ $did($dname,11).sel
}

on *:dialog:tabs:sclick:13: {
  if ($did($dname,7).text && $did($dname,9).text) {
    did -r $dname 15
    did -ra $dname 12 Searching... Please wait...
    set %tab_site www. $+ $did(tabs,11).seltext
    _tabconnect
  }
  else beep
}

alias -l _tabs_pref {
  if ($did(tabs,19).state = 1) {
    did -v tabs 20,21,22,23,24,25,26,27,28,29,30,31,32
    mdx MoveControl tabs 15 5 163 540 270
  }
  else {
    did -h tabs 20,21,22,23,24,25,26,27,28,29,30,31,32
    mdx MoveControl tabs 15 5 163 540 300
  }
}

alias -l _tabconnect {
  sockclose tabs
  sockopen tabs %tab_site 80
}

on *:sockopen:tabs:{
  if ($sockerr = 0) {
    var %a = $replace($did(tabs,7).text,$chr(32),_)
    var %s = $replace($did(tabs,9).text,$chr(32),_)
    var %g = $did(tabs,11).sel
    if (%g = 1) { 
      sockwrite -n $sockname GET /fetchurl.php?filename=/ $+ $left(%a,1) $+ / $+ %a $+ / $+ %s $+ .tab
      sockwrite -n $sockname Host: guitartabs.cc $+ $str($crlf ,2)
      did -ra tabs 12 Connected to website! Searching for tab...
      set %t 0
    }
    elseif (%g = 2) {
      sockwrite -n $sockname GET /dynamic/browse.php?printer=1&local=main/ $+ $left(%a,1) $+ / $+ %a $+ / $+ %s $+ .tab
      sockwrite -n $sockname Host: olga.net $+ $str($crlf ,2)
      did -ra tabs 12 Connected to website! Searching for tab...
      set %tab_html 0
    }
    elseif (%g = 3) {
      sockwrite -n $sockname GET /tabs/ $+ $left(%a,1) $+ / $+ %a $+ / $+ %s $+ _tab.htm
      sockwrite -n $sockname Host: ultimate-guitar.com $+ $str($crlf ,2)
      did -ra tabs 12 Connected to website! Searching for tab...
      set %tab_html 0
    }
  }
  else { did -ra tabs 12 ERROR! Could not establish connection. Spelling mistake? }
}

on *:sockread:tabs:{
  sockread %tab
  if ($did(tabs,11).sel = 1) {
    if (*</STYLE><PRE>* iswm %tab) { set %tab_html 1 }
    if (%tab_html = 1 && *</PRE>* !iswm %tab) { did -a tabs 15 %tab $crlf }
    if (*</PRE>* iswm %tab) { set %tab_html 0 }
  }
  elseif ($did(tabs,11).sel = 2) { did -a tabs 15 %tab $crlf }
  elseif ($did(tabs,11).sel = 3) {
    if (*<table cellspacing=0 cellpadding=0 width=100%><tr><td width="100%"><font color="black" style="font:12px Courier New"><b>* iswm %tab) { did -a tabs 15 $remove($gettok(%tab,6-8,62),</b,<b>,</b>,>) $crlf | set %tab_html 1 }
    if (%tab_html = 1 && *<table cellspacing=0 cellpadding=0 width=100%><tr><td width="100%"><font color="black" style="font:12px Courier New"><b>* !iswm %tab) { did -a tabs 15 $remove(%tab,</pre></font></td>,<br><pre>) $crlf }
    if (*</pre></font></td>* iswm %tab) { set %tab_html 0 }
  }
  if (*file not found on mirror* iswm %tab) { did -ra tabs 12 Guitar tab not found! }
  if (*Sorry the specified location was not found, please try again.* iswm %tab) { did -ra tabs 12 Guitar tab not found! | did -r tabs 15 | sockclose tabs }
  unset %tab
}

on *:sockclose:tabs:{
  if (%tab_site = www.Guitartabs.cc) {
    did -d tabs 15 1
  }
  if ($did(tabs,15,5)) did -ra tabs 12 Guitar tab retrived successfully!
  did -ra tabs 16 $cap($did(tabs,7).text)
  did -ra tabs 17 $cap($did(tabs,9).text)
  did -ra tabs 18 From $cap($did(tabs,11).seltext)
  did -c tabs 15 1
  unset %tab_html
}

alias cap {
  return $upper($mid($1-,1,1)) $+ $mid($1-,2,$len($1-))
}

alias mdx return $dll($scriptdirmdx.dll,$1,$2-) 
